#ifdef ORIGINALLINUXCRAP
 /*
  *  Bit simplified and optimized by Jan Hubicka
  */

#ifdef SLOW_IO_BY_JUMPING
#define __SLOW_DOWN_IO "\njmp 1f\n1:\tjmp 1f\n1:"
#else
#define __SLOW_DOWN_IO "\noutb %%al,$0x80"
#endif

#ifdef REALLY_SLOW_IO
#define __FULL_SLOW_DOWN_IO __SLOW_DOWN_IO __SLOW_DOWN_IO __SLOW_DOWN_IO __SLOW_DOWN_IO
#else
#define __FULL_SLOW_DOWN_IO __SLOW_DOWN_IO
#endif

/*
 * Talk about misusing macros..
 */
#define __OUT1(s,x) \
extern inline void out##s(unsigned x value, unsigned short port) {

#define __OUT2(s,s1,s2) \
__asm__ __volatile__ ("out" #s " %" s1 "0,%" s2 "1"

#define __OUT(s,s1,x) \
__OUT1(s,x) __OUT2(s,s1,"w") : : "a" (value), "Nd" (port)); } \
__OUT1(s##_p,x) __OUT2(s,s1,"w") __FULL_SLOW_DOWN_IO : : "a" (value), "Nd" (port));} \

#define __IN1(s) \
extern inline RETURN_TYPE in##s(unsigned short port) { RETURN_TYPE _v;

#define __IN2(s,s1,s2) \
__asm__ __volatile__ ("in" #s " %" s2 "1,%" s1 "0"

#define __IN(s,s1,i) \
__IN1(s) __IN2(s,s1,"w") : "=a" (_v) : "Nd" (port) ,##i ); return _v; } \
__IN1(s##_p) __IN2(s,s1,"w") __FULL_SLOW_DOWN_IO : "=a" (_v) : "Nd" (port) ,##i ); return _v; } \

#define __INS(s) \
extern inline void ins##s(unsigned short port, void * addr, unsigned long count) \
{ __asm__ __volatile__ ("cld ; rep ; ins" #s \
: "=D" (addr), "=c" (count) : "d" (port),"0" (addr),"1" (count)); }

#define __OUTS(s) \
extern inline void outs##s(unsigned short port, const void * addr, unsigned long count) \
{ __asm__ __volatile__ ("cld ; rep ; outs" #s \
: "=S" (addr), "=c" (count) : "d" (port),"0" (addr),"1" (count)); }

#define RETURN_TYPE unsigned char
__IN(b,"")
#undef RETURN_TYPE
#define RETURN_TYPE unsigned short
__IN(w,"")
#undef RETURN_TYPE
#define RETURN_TYPE unsigned int
__IN(l,"")
#undef RETURN_TYPE

__OUT(b,"b",char)
__OUT(w,"w",short)
__OUT(l,,int)

__INS(b)
__INS(w)
__INS(l)

__OUTS(b)
__OUTS(w)
__OUTS(l)
#endif

unsigned char  inb  (unsigned short port) {
	unsigned char  _v;
	__asm__ __volatile__ ("inb %w1,%0"  : "=a" (_v) : "Nd" (port)  ); return _v; } 

unsigned char  inb_p (unsigned short port) { unsigned char  _v;  __asm__ __volatile__ ("in" "b" " %"  "w"  "1,%"   ""   "0"  "\noutb %%al,$0x80"   : "=a" (_v) : "Nd" (port)  ); return _v; } 


unsigned short  inw  (unsigned short port) { unsigned short  _v;  __asm__ __volatile__ ("in" "w" " %"  "w"  "1,%"   ""   "0"  : "=a" (_v) : "Nd" (port)  ); return _v; } extern inline unsigned short  inw_p (unsigned short port) { unsigned short  _v;  __asm__ __volatile__ ("in" "w" " %"  "w"  "1,%"   ""   "0"  "\noutb %%al,$0x80"   : "=a" (_v) : "Nd" (port)   ); return _v; } 


unsigned int  inl  (unsigned short port) { unsigned int  _v;  __asm__ __volatile__ ("in" "l" " %"  "w"  "1,%"   ""   "0"  : "=a" (_v) : "Nd" (port) ); return _v; } extern inline unsigned int  inl_p (unsigned short port) { unsigned int  _v;  __asm__ __volatile__ ("in" "l" " %"  "w"  "1,%"   ""   "0"  "\noutb %%al,$0x80"   : "=a" (_v) : "Nd" (port)   ); return _v; } 


void outb  (unsigned   char   value, unsigned short port) {  __asm__ __volatile__ ("out" "b" " %"   "b"   "0,%"  "w"  "1"  : : "a" (value), "Nd" (port)); }  void outb_p (unsigned   char   value, unsigned short port) {  __asm__ __volatile__ ("out" "b" " %"   "b"   "0,%"  "w"  "1"  "\noutb %%al,$0x80"   : : "a" (value), "Nd" (port));} 
void outw  (unsigned   short   value, unsigned short port) {  __asm__ __volatile__ ("out" "w" " %"   "w"   "0,%"  "w"  "1"  : : "a" (value), "Nd" (port)); }  void outw_p (unsigned   short   value, unsigned short port) {  __asm__ __volatile__ ("out" "w" " %"   "w"   "0,%"  "w"  "1"  "\noutb %%al,$0x80"   : : "a" (value), "Nd" (port));} 
void outl  (unsigned   int   value, unsigned short port) {  __asm__ __volatile__ ("out" "l" " %"      "0,%"  "w"  "1"  : : "a" (value), "Nd" (port)); } void outl_p (unsigned   int   value, unsigned short port) {  __asm__ __volatile__ ("out" "l" " %"      "0,%"  "w"  "1"  "\noutb %%al,$0x80"   : : "a" (value), "Nd" (port));} 

void insb (unsigned short port, void * addr, unsigned long count) { __asm__ __volatile__ ("cld ; rep ; ins" "b" : "=D" (addr), "=c" (count) : "d" (port),"0" (addr),"1" (count)); } 
void insw (unsigned short port, void * addr, unsigned long count) { __asm__ __volatile__ ("cld ; rep ; ins" "w" : "=D" (addr), "=c" (count) : "d" (port),"0" (addr),"1" (count)); } 
void insl (unsigned short port, void * addr, unsigned long count) { __asm__ __volatile__ ("cld ; rep ; ins" "l" : "=D" (addr), "=c" (count) : "d" (port),"0" (addr),"1" (count)); } 

void outsb (unsigned short port, const void * addr, unsigned long count) { __asm__ __volatile__ ("cld ; rep ; outs" "b" : "=S" (addr), "=c" (count) : "d" (port),"0" (addr),"1" (count)); } 
void outsw (unsigned short port, const void * addr, unsigned long count) { __asm__ __volatile__ ("cld ; rep ; outs" "w" : "=S" (addr), "=c" (count) : "d" (port),"0" (addr),"1" (count)); } 
void outsl (unsigned short port, const void * addr, unsigned long count) { __asm__ __volatile__ ("cld ; rep ; outs" "l" : "=S" (addr), "=c" (count) : "d" (port),"0" (addr),"1" (count)); } 

#include <u.h>
#include <libc.h>
#include "vga.h"

long curprintindex;

static long iobfd = -1;
static long iowfd = -1;
static long iolfd = -1;
static long biosfd = -1;

enum {
	Nctlchar	= 256,
	Nattr		= 16,
};

static long ctlfd = -1;
static char ctlbuf[Nctlchar];
static long ctlclean;

static struct {
	char*	attr;
	char*	val;
} attr[Nattr];

uchar
inportb(long port)
{
	return inb(port);
}

void
outportb(long port, uchar data)
{
	outb_p(data, port);
}

ushort
inportw(long port)
{
	return inw(port);
}

void
outportw(long port, ushort data)
{
	outw(data, port);
}

ulong
inportl(long port)
{
	return inl(port);
}

void
outportl(long port, ulong data)
{
	outl(data, port);
}
void
vgactlinit(void)
{
	if(open("/dev/io", O_RDONLY) < 0)
		error("cannot open /dev/io");
}

char*
vgactlr(char* a, char* v)
{
	long i;

	trace("vgactlr: look for %s\n", a);
	vgactlinit();
	for(i = 0; attr[i].attr; i++){
		if(strcmp(attr[i].attr, a) == 0){
			strcpy(v, attr[i].val);
			trace("vgactlr: value %s\n", v);
			return v;
		}
	}
	trace("vgactlr: %s not found\n", a);

	return 0;
}

void
vgactlw(char* attr, char* val)
{}

void
setpalette(long p, long r, long g, long b)
{
	vgao(PaddrW, p);
	vgao(Pdata, r);
	vgao(Pdata, g);
	vgao(Pdata, b);
}

long
readbios(char* buf, long len, long offset)
{return 0;}

void
dumpbios(void)
{}

void*
alloc(ulong nbytes)
{
	void *v;

	if((v = malloc(nbytes)) == 0)
		error("alloc: %d bytes - %r\n", nbytes);

	return memset(v, 0, nbytes);
}

void
printitem(char* ctlr, char* item)
{
	int n;

	if(curprintindex){
		curprintindex = 0;
		fprintf(stdout, "\n");
	}

	n = 0;
	if(ctlr && *ctlr)
		n = fprintf(stdout, "%s ", ctlr);
	fprintf(stdout, "%-*s", 20-n, item);
}

void
printreg(ulong data)
{
	int width;

	width = 3;
	if((curprintindex % 16) == 0 && curprintindex){
		fprintf(stdout, "\n");
		curprintindex = 0;
		width = 23;
	}
	if(curprintindex == 8)
		fprintf(stdout, " -");
	fprintf(stdout, "%*.2X", width, (int)data);
	curprintindex++;
}

static char *flagname[32] = {
	/*0x00*/	"Fsnarf",
	/*0x01*/	"Foptions",
	/*0x02*/	"Finit",
	/*0x03*/	"Fload",
	/*0x04*/	"Fdump",
	0,
	0,
	0,
	/*0x08*/	"Hpclk2x8",
	/*0x09*/	"Upclk2x8",
	/*0x0A*/	"Henhanced",
	/*0x0B*/	"Uenhanced",
	/*0x0C*/	"Hpvram",
	/*0x0D*/	"Upvram",
	/*0x0E*/	"Hextsid",
	/*0x0F*/	"Uextsid",
	/*0x10*/	"Hclk2",
	/*0x11*/	"Uclk2",
	/*0x12*/	"Hlinear",
	/*0x13*/	"Ulinear",
	/*0x14*/	"Hclkdiv",
	/*0x15*/	"Uclkdiv",
	/*0x16*/	"Hsid32",
};

void
printflag(ulong flag)
{
	long i;
	char first;

	first = ' ';
	for(i = 31; i >= 0; i--){
		if((flag & (1<<i)) == 0)
			continue;
		if(flagname[i])
			fprintf(stdout, "%c%s", first, flagname[i]);
		else
			fprintf(stdout, "%c0x%x", first, 1<<i);
		first = '|';
	}
}
