#include <u.h>
#include <libc.h>

#include "vga.h"

long vflag, Vflag;

void
error(char* format, ...)
{
	char buf[512];
	va_list arg;
	long n;

	sequencer(0, 1);
	n = sprint(buf, "%s: ", argv0);
	va_start(arg, format);
	doprint(buf+n, buf+sizeof(buf)-n, format, arg);
	va_end(arg);
	if(vflag)
		fprintf(stdout, buf+n);
	Bflush(stdout);
	fprintf(stderr, buf);
	exits("error");
}

void
trace(char* format, ...)
{
	char buf[512];
	va_list arg;

	if(vflag || Vflag){
		if(curprintindex){
			curprintindex = 0;
			fprintf(stdout, "\n");
		}
		va_start(arg, format);
		doprint(buf, buf+sizeof(buf), format, arg);
		va_end(arg);
		fprintf(stdout, buf);
		if(Vflag)
			print(buf);
	}
}
