#include <u.h>
#include <libc.h>
#include <conio.h>

#include "vga.h"

long curprintindex;

static long iobfd = -1;
static long iowfd = -1;
static long iolfd = -1;
static long biosfd = -1;

enum {
	Nctlchar	= 256,
	Nattr		= 16,
};

static long ctlfd = -1;
static char ctlbuf[Nctlchar];
static long ctlclean;

static struct {
	char*	attr;
	char*	val;
} attr[Nattr];

uchar
inportb(long port)
{
	uchar a;

	_asm {
		mov edx, port
		in al, dx
		mov a, al
	}
	return a;
}

void
outportb(long port, uchar data)
{
	_asm {
		mov edx, port
		mov al, data
		out dx, al
	}
}

ushort
inportw(long port)
{
	ushort a;
	_asm {
		mov edx, port
		xor eax, eax
		in ax, dx
		mov a, ax
	}
	return a;
}

void
outportw(long port, ushort data)
{
	_asm {
		mov edx, port
		mov ax, data
		out dx, ax
	}
}

ulong
inportl(long port)
{
	ulong a;

	_asm {
		mov edx, port
		in eax, dx
		mov a, eax
	}
	return a;
}

void
outportl(long port, ulong data)
{
	_asm {
		mov edx, port
		mov eax, data
		out dx, eax
	}
}
static void
vgactlinit(void)
{}

char*
vgactlr(char* a, char* v)
{
	long i;

	trace("vgactlr: look for %s\n", a);
	vgactlinit();
	for(i = 0; attr[i].attr; i++){
		if(strcmp(attr[i].attr, a) == 0){
			strcpy(v, attr[i].val);
			trace("vgactlr: value %s\n", v);
			return v;
		}
	}
	trace("vgactlr: %s not found\n", a);

	return 0;
}

void
vgactlw(char* attr, char* val)
{}

void
setpalette(long p, long r, long g, long b)
{
	vgao(PaddrW, p);
	vgao(Pdata, r);
	vgao(Pdata, g);
	vgao(Pdata, b);
}

long
readbios(char* buf, long len, long offset)
{return 0;}

void
dumpbios(void)
{}

void*
alloc(ulong nbytes)
{
	void *v;

	if((v = malloc(nbytes)) == 0)
		error("alloc: %d bytes - %r\n", nbytes);

	return memset(v, 0, nbytes);
}

void
printitem(char* ctlr, char* item)
{
	int n;

	if(curprintindex){
		curprintindex = 0;
		fprintf(stdout, "\n");
	}

	n = 0;
	if(ctlr && *ctlr)
		n = fprintf(stdout, "%s ", ctlr);
	fprintf(stdout, "%-*s", 20-n, item);
}

void
printreg(ulong data)
{
	int width;

	width = 3;
	if((curprintindex % 16) == 0 && curprintindex){
		fprintf(stdout, "\n");
		curprintindex = 0;
		width = 23;
	}
	if(curprintindex == 8)
		fprintf(stdout, " -");
	fprintf(stdout, "%*.2X", width, (int)data);
	curprintindex++;
}

static char *flagname[32] = {
	/*0x00*/	"Fsnarf",
	/*0x01*/	"Foptions",
	/*0x02*/	"Finit",
	/*0x03*/	"Fload",
	/*0x04*/	"Fdump",
	0,
	0,
	0,
	/*0x08*/	"Hpclk2x8",
	/*0x09*/	"Upclk2x8",
	/*0x0A*/	"Henhanced",
	/*0x0B*/	"Uenhanced",
	/*0x0C*/	"Hpvram",
	/*0x0D*/	"Upvram",
	/*0x0E*/	"Hextsid",
	/*0x0F*/	"Uextsid",
	/*0x10*/	"Hclk2",
	/*0x11*/	"Uclk2",
	/*0x12*/	"Hlinear",
	/*0x13*/	"Ulinear",
	/*0x14*/	"Hclkdiv",
	/*0x15*/	"Uclkdiv",
	/*0x16*/	"Hsid32",
};

void
printflag(ulong flag)
{
	long i;
	char first;

	first = ' ';
	for(i = 31; i >= 0; i--){
		if((flag & (1<<i)) == 0)
			continue;
		if(flagname[i])
			fprintf(stdout, "%c%s", first, flagname[i]);
		else
			fprintf(stdout, "%c0x%x", first, 1<<i);
		first = '|';
	}
}
